--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/comm/action/card.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/comm/action/card.php	2025-05-26 12:57:19.098506000 +0000
@@ -2820,29 +3100,50 @@
 	$reshook = $hookmanager->executeHooks('addMoreActionsButtons', $parameters, $object, $action); // Note that $action and $object may have been modified by hook
 	if (empty($reshook)) {
 		if ($action != 'edit') {
-			if ($user->hasRight('agenda', 'allactions', 'create') ||
-			   (($object->authorid == $user->id || $object->userownerid == $user->id) && $user->hasRight('agenda', 'myactions', 'create'))) {
-				print '<div class="inline-block divButAction"><a class="butAction" href="card.php?action=edit&token='.newToken().'&id='.$object->id.'">'.$langs->trans("Modify").'</a></div>';
+			if (
+				$user->hasRight('agenda', 'allactions', 'create') ||
+				(($object->authorid == $user->id || $object->userownerid == $user->id) && $user->hasRight('agenda', 'myactions', 'create'))
+			) {
+				print '<div class="inline-block divButAction"><a class="butAction" href="card.php?action=edit&token=' . newToken() . '&id=' . $object->id . '">' . $langs->trans("Modify") . '</a></div>';
 			} else {
-				print '<div class="inline-block divButAction"><a class="butActionRefused classfortooltip" href="#" title="'.$langs->trans("NotAllowed").'">'.$langs->trans("Modify").'</a></div>';
+				print '<div class="inline-block divButAction"><a class="butActionRefused classfortooltip" href="#" title="' . $langs->trans("NotAllowed") . '">' . $langs->trans("Modify") . '</a></div>';
 			}
 
-			if ($user->hasRight('agenda', 'allactions', 'create') ||
-			   (($object->authorid == $user->id || $object->userownerid == $user->id) && $user->hasRight('agenda', 'myactions', 'create'))) {
-				print '<div class="inline-block divButAction"><a class="butAction" href="card.php?action=clone&object='.$object->element.'&id='.$object->id.'">'.$langs->trans("ToClone").'</a></div>';
+			if (
+				$user->hasRight('agenda', 'allactions', 'create') ||
+				(($object->authorid == $user->id || $object->userownerid == $user->id) && $user->hasRight('agenda', 'myactions', 'create'))
+			) {
+				print '<div class="inline-block divButAction"><a class="butAction" href="card.php?action=clone&object=' . $object->element . '&id=' . $object->id . '">' . $langs->trans("ToClone") . '</a></div>';
 			} else {
-				print '<div class="inline-block divButAction"><a class="butActionRefused classfortooltip" href="#" title="'.$langs->trans("NotAllowed").'">'.$langs->trans("ToClone").'</a></div>';
+				print '<div class="inline-block divButAction"><a class="butActionRefused classfortooltip" href="#" title="' . $langs->trans("NotAllowed") . '">' . $langs->trans("ToClone") . '</a></div>';
 			}
 
-			if ($user->hasRight('agenda', 'allactions', 'delete') ||
-			   (($object->authorid == $user->id || $object->userownerid == $user->id) && $user->hasRight('agenda', 'myactions', 'delete'))) {
-				print '<div class="inline-block divButAction"><a class="butActionDelete" href="card.php?action=delete&token='.newToken().'&id='.$object->id.'">'.$langs->trans("Delete").'</a></div>';
+			if (
+				$user->hasRight('agenda', 'allactions', 'delete') ||
+				(($object->authorid == $user->id || $object->userownerid == $user->id) && $user->hasRight('agenda', 'myactions', 'delete'))
+			) {
+				print '<div class="inline-block divButAction"><a class="butActionDelete" href="card.php?action=delete&token=' . newToken() . '&id=' . $object->id . '">' . $langs->trans("Delete") . '</a></div>';
 			} else {
-				print '<div class="inline-block divButAction"><a class="butActionRefused classfortooltip" href="#" title="'.$langs->trans("NotAllowed").'">'.$langs->trans("Delete").'</a></div>';
+				print '<div class="inline-block divButAction"><a class="butActionRefused classfortooltip" href="#" title="' . $langs->trans("NotAllowed") . '">' . $langs->trans("Delete") . '</a></div>';
 			}
 		}
 	}
 
+	$url = dol_buildpath('/custom/reminderevents/reminders_list_event.php', 1) . '?eventid=' . $object->id;
+	print '<td><a class="nowrap" href="' . $url . '">' . "lien list" . ' ' . img_picto($langs->trans("Edit"), 'edit') . '</a></td>';
+
+	// $button = dolButtonToOpenUrlInDialogPopup(
+	// 	'eventReminders',
+	// 	$langs->trans("Reminders"),
+	// 	img_picto('', 'bell') . ' ' . $langs->trans("ShowReminders"),
+	// 	$url,
+	// 	'',
+	// 	'nohover'
+	// );
+
+	// Affiche le bouton dans le bloc des actions
+	print '<div class="inline-block">' . $button . '</div>';
+
 	print '</div>';
 
 	if ($action != 'edit') {
@@ -2854,8 +3155,8 @@
 			 * Generated documents
 			 */
 
-			$filedir = $conf->agenda->multidir_output[$conf->entity].'/'.$object->id;
-			$urlsource = $_SERVER["PHP_SELF"]."?id=".$object->id;
+			$filedir = $conf->agenda->multidir_output[$conf->entity] . '/' . $object->id;
+			$urlsource = $_SERVER["PHP_SELF"] . "?id=" . $object->id;
 
 			$genallowed = $user->hasRight('agenda', 'myactions', 'read');
 			$delallowed = $user->hasRight('agenda', 'myactions', 'create');

########## comm/propal/list.php
--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/comm/propal/list.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/comm/propal/list.php	2025-03-17 14:10:29.831059000 +0000
@@ -42,20 +42,20 @@
 
 // Load Dolibarr environment
 require '../../main.inc.php';
-require_once DOL_DOCUMENT_ROOT.'/core/class/html.formother.class.php';
-require_once DOL_DOCUMENT_ROOT.'/core/class/html.formfile.class.php';
-require_once DOL_DOCUMENT_ROOT.'/core/class/html.formpropal.class.php';
-require_once DOL_DOCUMENT_ROOT.'/core/class/html.formcompany.class.php';
+require_once DOL_DOCUMENT_ROOT . '/core/class/html.formother.class.php';
+require_once DOL_DOCUMENT_ROOT . '/core/class/html.formfile.class.php';
+require_once DOL_DOCUMENT_ROOT . '/core/class/html.formpropal.class.php';
+require_once DOL_DOCUMENT_ROOT . '/core/class/html.formcompany.class.php';
 if (isModEnabled('margin')) {
-	require_once DOL_DOCUMENT_ROOT.'/core/class/html.formmargin.class.php';
+	require_once DOL_DOCUMENT_ROOT . '/core/class/html.formmargin.class.php';
 }
-require_once DOL_DOCUMENT_ROOT.'/core/lib/date.lib.php';
-require_once DOL_DOCUMENT_ROOT.'/core/lib/company.lib.php';
-require_once DOL_DOCUMENT_ROOT.'/comm/propal/class/propal.class.php';
-require_once DOL_DOCUMENT_ROOT.'/projet/class/project.class.php';
+require_once DOL_DOCUMENT_ROOT . '/core/lib/date.lib.php';
+require_once DOL_DOCUMENT_ROOT . '/core/lib/company.lib.php';
+require_once DOL_DOCUMENT_ROOT . '/comm/propal/class/propal.class.php';
+require_once DOL_DOCUMENT_ROOT . '/projet/class/project.class.php';
 if (isModEnabled('category')) {
-	require_once DOL_DOCUMENT_ROOT.'/categories/class/categorie.class.php';
-	require_once DOL_DOCUMENT_ROOT.'/core/class/html.formcategory.class.php';
+	require_once DOL_DOCUMENT_ROOT . '/categories/class/categorie.class.php';
+	require_once DOL_DOCUMENT_ROOT . '/core/class/html.formcategory.class.php';
 }
 
 /**
@@ -196,7 +196,7 @@
 $hookmanager->initHooks(array('propallist'));
 $result = restrictedArea($user, $module, $objectid, $dbtable);
 
-$diroutputmassaction = $conf->propal->multidir_output[$conf->entity].'/temp/massgeneration/'.$user->id;
+$diroutputmassaction = $conf->propal->multidir_output[$conf->entity] . '/temp/massgeneration/' . $user->id;
 
 // Initialize a technical object to manage hooks of page. Note that conf->hooks_modules contains an array of hook context
 $object = new Propal($db);
@@ -302,7 +302,7 @@
 }
 
 // Extra fields
-include DOL_DOCUMENT_ROOT.'/core/tpl/extrafields_list_array_fields.tpl.php';
+include DOL_DOCUMENT_ROOT . '/core/tpl/extrafields_list_array_fields.tpl.php';
 
 // Permissions
 $permissiontoread = $user->hasRight('propal', 'lire');
@@ -343,7 +343,7 @@
 
 if (empty($reshook)) {
 	// Selection of new fields
-	include DOL_DOCUMENT_ROOT.'/core/actions_changeselectedfields.inc.php';
+	include DOL_DOCUMENT_ROOT . '/core/actions_changeselectedfields.inc.php';
 
 	// Purge search criteria
 	if (GETPOST('button_removefilter_x', 'alpha') || GETPOST('button_removefilter.x', 'alpha') || GETPOST('button_removefilter', 'alpha')) { // All tests are required to be compatible with all browsers
@@ -425,7 +425,7 @@
 	$objectclass = 'Propal';
 	$objectlabel = 'Proposals';
 	$uploaddir = $conf->propal->multidir_output[$conf->entity];
-	include DOL_DOCUMENT_ROOT.'/core/actions_massactions.inc.php';
+	include DOL_DOCUMENT_ROOT . '/core/actions_massactions.inc.php';
 }
 
 if ($action == 'validate' && $permissiontovalidate) {
@@ -468,7 +468,7 @@
 				if ($tmpproposal->status == $tmpproposal::STATUS_VALIDATED) {
 					$tmpproposal->status = $tmpproposal::STATUS_SIGNED;
 					if ($tmpproposal->closeProposal($user, $tmpproposal::STATUS_SIGNED) >= 0) {
-						setEventMessages($tmpproposal->ref." ".$langs->trans('Signed'), null, 'mesgs');
+						setEventMessages($tmpproposal->ref . " " . $langs->trans('Signed'), null, 'mesgs');
 					} else {
 						setEventMessages($tmpproposal->error, $tmpproposal->errors, 'errors');
 						$error++;
@@ -499,13 +499,13 @@
 				if ($tmpproposal->status == $tmpproposal::STATUS_VALIDATED || (getDolGlobalString('PROPAL_SKIP_ACCEPT_REFUSE') && $tmpproposal->statut == $tmpproposal::STATUS_DRAFT)) {
 					$tmpproposal->status = $tmpproposal::STATUS_NOTSIGNED;
 					if ($tmpproposal->closeProposal($user, $tmpproposal::STATUS_NOTSIGNED) > 0) {
-						setEventMessage($tmpproposal->ref." ".$langs->trans('NoSigned'), 'mesgs');
+						setEventMessage($tmpproposal->ref . " " . $langs->trans('NoSigned'), 'mesgs');
 					} else {
 						setEventMessages($tmpproposal->error, $tmpproposal->errors, 'errors');
 						$error++;
 					}
 				} else {
-					setEventMessage($tmpproposal->ref." ".$langs->trans('CantBeNoSign'), 'errors');
+					setEventMessage($tmpproposal->ref . " " . $langs->trans('CantBeNoSign'), 'errors');
 					$error++;
 				}
 			} else {
@@ -596,7 +596,7 @@
 // Add fields from extrafields
 if (!empty($extrafields->attributes[$object->table_element]['label'])) {
 	foreach ($extrafields->attributes[$object->table_element]['label'] as $key => $val) {
-		$sql .= ($extrafields->attributes[$object->table_element]['type'][$key] != 'separate' ? ", ef.".$key." as options_".$key : '');
+		$sql .= ($extrafields->attributes[$object->table_element]['type'][$key] != 'separate' ? ", ef." . $key . " as options_" . $key : '');
 	}
 }
 // Add fields from hooks
@@ -607,28 +607,28 @@
 
 $sqlfields = $sql; // $sql fields to remove for count total
 
-$sql .= ' FROM '.MAIN_DB_PREFIX.'societe as s';
-$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."c_country as country on (country.rowid = s.fk_pays)";
-$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."c_typent as typent on (typent.id = s.fk_typent)";
-$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."c_departements as state on (state.rowid = s.fk_departement)";
+$sql .= ' FROM ' . MAIN_DB_PREFIX . 'societe as s';
+$sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_country as country on (country.rowid = s.fk_pays)";
+$sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_typent as typent on (typent.id = s.fk_typent)";
+$sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_departements as state on (state.rowid = s.fk_departement)";
 
-$sql .= ' INNER JOIN '.MAIN_DB_PREFIX.'propal as p ON p.fk_soc = s.rowid';
+$sql .= ' INNER JOIN ' . MAIN_DB_PREFIX . 'propal as p ON p.fk_soc = s.rowid';
 if (!empty($extrafields->attributes[$object->table_element]['label']) && is_array($extrafields->attributes[$object->table_element]['label']) && count($extrafields->attributes[$object->table_element]['label'])) {
-	$sql .= " LEFT JOIN ".MAIN_DB_PREFIX.$object->table_element."_extrafields as ef on (p.rowid = ef.fk_object)";
+	$sql .= " LEFT JOIN " . MAIN_DB_PREFIX . $object->table_element . "_extrafields as ef on (p.rowid = ef.fk_object)";
 }
 if ($search_all) {
-	$sql .= ' LEFT JOIN '.MAIN_DB_PREFIX.'propaldet as pd ON p.rowid = pd.fk_propal';
+	$sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'propaldet as pd ON p.rowid = pd.fk_propal';
 }
-$sql .= ' LEFT JOIN '.MAIN_DB_PREFIX.'user as u ON p.fk_user_author = u.rowid';
-$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."projet as pr ON pr.rowid = p.fk_projet";
-$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."c_availability as ava on (ava.rowid = p.fk_availability)";
+$sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'user as u ON p.fk_user_author = u.rowid';
+$sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "projet as pr ON pr.rowid = p.fk_projet";
+$sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_availability as ava on (ava.rowid = p.fk_availability)";
 // Add table from hooks
 $parameters = array();
 $reshook = $hookmanager->executeHooks('printFieldListFrom', $parameters, $object); // Note that $action and $object may have been modified by hook
 $sql .= $hookmanager->resPrint;
 
 $sql .= ' WHERE';
-$sql .= ' p.entity IN ('.getEntity('propal').')';
+$sql .= ' p.entity IN (' . getEntity('propal') . ')';
 if ($search_town) {
 	$sql .= natural_search('s.town', $search_town);
 }
@@ -639,10 +639,10 @@
 	$sql .= natural_search("state.nom", $search_state);
 }
 if ($search_country) {
-	$sql .= " AND s.fk_pays IN (".$db->sanitize($db->escape($search_country)).')';
+	$sql .= " AND s.fk_pays IN (" . $db->sanitize($db->escape($search_country)) . ')';
 }
 if ($search_type_thirdparty != '' && $search_type_thirdparty > 0) {
-	$sql .= " AND s.fk_typent IN (".$db->sanitize($db->escape($search_type_thirdparty)).')';
+	$sql .= " AND s.fk_typent IN (" . $db->sanitize($db->escape($search_type_thirdparty)) . ')';
 }
 if ($search_ref) {
 	$sql .= natural_search('p.ref', $search_ref);
@@ -657,7 +657,7 @@
 	$sql .= natural_search('pr.title', $search_project);
 }
 if ($search_availability) {
-	$sql .= " AND p.fk_availability IN (".$db->sanitize($db->escape($search_availability)).')';
+	$sql .= " AND p.fk_availability IN (" . $db->sanitize($db->escape($search_availability)) . ')';
 }
 $societe_add_ref_in_list = getDolGlobalInt('SOCIETE_ADD_REF_IN_LIST');
 if (empty($arrayfields['s.name_alias']['checked']) && $search_societe) {
@@ -698,7 +698,7 @@
 	$sql .= natural_search("p.fk_warehouse", $search_warehouse, 1);
 }
 if ($search_multicurrency_code != '') {
-	$sql .= " AND p.multicurrency_code = '".$db->escape($search_multicurrency_code)."'";
+	$sql .= " AND p.multicurrency_code = '" . $db->escape($search_multicurrency_code) . "'";
 }
 if ($search_multicurrency_tx != '') {
 	$sql .= natural_search('p.multicurrency_tx', $search_multicurrency_tx, 1);
@@ -716,49 +716,49 @@
 	$sql .= natural_search(array_keys($fieldstosearchall), $search_all);
 }
 if ($search_fk_cond_reglement > 0) {
-	$sql .= " AND p.fk_cond_reglement = ".((int) $search_fk_cond_reglement);
+	$sql .= " AND p.fk_cond_reglement = " . ((int) $search_fk_cond_reglement);
 }
 if ($search_fk_shipping_method > 0) {
-	$sql .= " AND p.fk_shipping_method = ".((int) $search_fk_shipping_method);
+	$sql .= " AND p.fk_shipping_method = " . ((int) $search_fk_shipping_method);
 }
 if ($search_fk_input_reason > 0) {
-	$sql .= " AND p.fk_input_reason = ".((int) $search_fk_input_reason);
+	$sql .= " AND p.fk_input_reason = " . ((int) $search_fk_input_reason);
 }
 if ($search_fk_mode_reglement > 0) {
-	$sql .= " AND p.fk_mode_reglement = ".((int) $search_fk_mode_reglement);
+	$sql .= " AND p.fk_mode_reglement = " . ((int) $search_fk_mode_reglement);
 }
 if ($socid > 0) {
-	$sql .= ' AND s.rowid = '.((int) $socid);
+	$sql .= ' AND s.rowid = ' . ((int) $socid);
 }
 if ($search_status != '' && $search_status != '-1') {
-	$sql .= ' AND p.fk_statut IN ('.$db->sanitize($search_status).')';
+	$sql .= ' AND p.fk_statut IN (' . $db->sanitize($search_status) . ')';
 }
 if ($search_date_start) {
-	$sql .= " AND p.datep >= '".$db->idate($search_date_start)."'";
+	$sql .= " AND p.datep >= '" . $db->idate($search_date_start) . "'";
 }
 if ($search_date_end) {
-	$sql .= " AND p.datep <= '".$db->idate($search_date_end)."'";
+	$sql .= " AND p.datep <= '" . $db->idate($search_date_end) . "'";
 }
 if ($search_date_end_start) {
-	$sql .= " AND p.fin_validite >= '".$db->idate($search_date_end_start)."'";
+	$sql .= " AND p.fin_validite >= '" . $db->idate($search_date_end_start) . "'";
 }
 if ($search_date_end_end) {
-	$sql .= " AND p.fin_validite <= '".$db->idate($search_date_end_end)."'";
+	$sql .= " AND p.fin_validite <= '" . $db->idate($search_date_end_end) . "'";
 }
 if ($search_date_delivery_start) {
-	$sql .= " AND p.date_livraison >= '".$db->idate($search_date_delivery_start)."'";
+	$sql .= " AND p.date_livraison >= '" . $db->idate($search_date_delivery_start) . "'";
 }
 if ($search_date_delivery_end) {
-	$sql .= " AND p.date_livraison <= '".$db->idate($search_date_delivery_end)."'";
+	$sql .= " AND p.date_livraison <= '" . $db->idate($search_date_delivery_end) . "'";
 }
 if ($search_date_signature_start) {
-	$sql .= " AND p.date_signature >= '".$db->idate($search_date_signature_start)."'";
+	$sql .= " AND p.date_signature >= '" . $db->idate($search_date_signature_start) . "'";
 }
 if ($search_date_signature_end) {
-	$sql .= " AND p.date_signature <= '".$db->idate($search_date_signature_end)."'";
+	$sql .= " AND p.date_signature <= '" . $db->idate($search_date_signature_end) . "'";
 }
 if ($search_note_public) {
-	$sql .= " AND p.note_public LIKE '%".$db->escape($db->escapeforlike($search_note_public))."%'";
+	$sql .= " AND p.note_public LIKE '%" . $db->escape($db->escapeforlike($search_note_public)) . "%'";
 }
 if ($search_import_key) {
 	$sql .= natural_search("s.import_key", $search_import_key);
@@ -767,17 +767,17 @@
 if ($search_user > 0) {
 	$sql .= " AND EXISTS (";
 	$sql .= " SELECT ec.fk_c_type_contact, ec.element_id, ec.fk_socpeople";
-	$sql .= " FROM ".MAIN_DB_PREFIX."element_contact as ec";
-	$sql .= " INNER JOIN  ".MAIN_DB_PREFIX."c_type_contact as tc";
+	$sql .= " FROM " . MAIN_DB_PREFIX . "element_contact as ec";
+	$sql .= " INNER JOIN  " . MAIN_DB_PREFIX . "c_type_contact as tc";
 	$sql .= " ON ec.fk_c_type_contact = tc.rowid AND tc.element='propal' AND tc.source='internal'";
-	$sql .= " WHERE ec.element_id = p.rowid AND ec.fk_socpeople = ".((int) $search_user).")";
+	$sql .= " WHERE ec.element_id = p.rowid AND ec.fk_socpeople = " . ((int) $search_user) . ")";
 }
 // Search on sale representative
 if ($search_sale && $search_sale != '-1') {
 	if ($search_sale == -2) {
-		$sql .= " AND NOT EXISTS (SELECT sc.fk_soc FROM ".MAIN_DB_PREFIX."societe_commerciaux as sc WHERE sc.fk_soc = p.fk_soc)";
+		$sql .= " AND NOT EXISTS (SELECT sc.fk_soc FROM " . MAIN_DB_PREFIX . "societe_commerciaux as sc WHERE sc.fk_soc = p.fk_soc)";
 	} elseif ($search_sale > 0) {
-		$sql .= " AND EXISTS (SELECT sc.fk_soc FROM ".MAIN_DB_PREFIX."societe_commerciaux as sc WHERE sc.fk_soc = p.fk_soc AND sc.fk_user = ".((int) $search_sale).")";
+		$sql .= " AND EXISTS (SELECT sc.fk_soc FROM " . MAIN_DB_PREFIX . "societe_commerciaux as sc WHERE sc.fk_soc = p.fk_soc AND sc.fk_user = " . ((int) $search_sale) . ")";
 	}
 }
 // Search for tag/category ($searchCategoryCustomerList is an array of ID)
@@ -788,25 +788,25 @@
 	$listofcategoryid = '';
 	foreach ($searchCategoryCustomerList as $searchCategoryCustomer) {
 		if (intval($searchCategoryCustomer) == -2) {
-			$searchCategoryCustomerSqlList[] = "NOT EXISTS (SELECT cs.fk_soc FROM ".MAIN_DB_PREFIX."categorie_societe as cs WHERE s.rowid = cs.fk_soc)";
+			$searchCategoryCustomerSqlList[] = "NOT EXISTS (SELECT cs.fk_soc FROM " . MAIN_DB_PREFIX . "categorie_societe as cs WHERE s.rowid = cs.fk_soc)";
 		} elseif (intval($searchCategoryCustomer) > 0) {
 			if ($searchCategoryCustomerOperator == 0) {
-				$searchCategoryCustomerSqlList[] = " EXISTS (SELECT cs.fk_soc FROM ".MAIN_DB_PREFIX."categorie_societe as cs WHERE s.rowid = cs.fk_soc AND cs.fk_categorie = ".((int) $searchCategoryCustomer).")";
+				$searchCategoryCustomerSqlList[] = " EXISTS (SELECT cs.fk_soc FROM " . MAIN_DB_PREFIX . "categorie_societe as cs WHERE s.rowid = cs.fk_soc AND cs.fk_categorie = " . ((int) $searchCategoryCustomer) . ")";
 			} else {
-				$listofcategoryid .= ($listofcategoryid ? ', ' : '') .((int) $searchCategoryCustomer);
+				$listofcategoryid .= ($listofcategoryid ? ', ' : '') . ((int) $searchCategoryCustomer);
 			}
 		}
 	}
 	if ($listofcategoryid) {
-		$searchCategoryCustomerSqlList[] = " EXISTS (SELECT cs.fk_soc FROM ".MAIN_DB_PREFIX."categorie_societe as cs WHERE s.rowid = cs.fk_soc AND cs.fk_categorie IN (".$db->sanitize($listofcategoryid)."))";
+		$searchCategoryCustomerSqlList[] = " EXISTS (SELECT cs.fk_soc FROM " . MAIN_DB_PREFIX . "categorie_societe as cs WHERE s.rowid = cs.fk_soc AND cs.fk_categorie IN (" . $db->sanitize($listofcategoryid) . "))";
 	}
 	if ($searchCategoryCustomerOperator == 1) {
 		if (!empty($searchCategoryCustomerSqlList)) {
-			$sql .= " AND (".implode(' OR ', $searchCategoryCustomerSqlList).")";
+			$sql .= " AND (" . implode(' OR ', $searchCategoryCustomerSqlList) . ")";
 		}
 	} else {
 		if (!empty($searchCategoryCustomerSqlList)) {
-			$sql .= " AND (".implode(' AND ', $searchCategoryCustomerSqlList).")";
+			$sql .= " AND (" . implode(' AND ', $searchCategoryCustomerSqlList) . ")";
 		}
 	}
 }
@@ -818,33 +818,33 @@
 	$listofcategoryid = '';
 	foreach ($searchCategoryProductList as $searchCategoryProduct) {
 		if (intval($searchCategoryProduct) == -2) {
-			$searchCategoryProductSqlList[] = "NOT EXISTS (SELECT ck.fk_product FROM ".MAIN_DB_PREFIX."categorie_product as ck, ".MAIN_DB_PREFIX."propaldet as pd WHERE pd.fk_propal = p.rowid AND pd.fk_product = ck.fk_product)";
+			$searchCategoryProductSqlList[] = "NOT EXISTS (SELECT ck.fk_product FROM " . MAIN_DB_PREFIX . "categorie_product as ck, " . MAIN_DB_PREFIX . "propaldet as pd WHERE pd.fk_propal = p.rowid AND pd.fk_product = ck.fk_product)";
 		} elseif (intval($searchCategoryProduct) > 0) {
 			if ($searchCategoryProductOperator == 0) {
-				$searchCategoryProductSqlList[] = " EXISTS (SELECT ck.fk_product FROM ".MAIN_DB_PREFIX."categorie_product as ck, ".MAIN_DB_PREFIX."propaldet as pd WHERE pd.fk_propal = p.rowid AND pd.fk_product = ck.fk_product AND ck.fk_categorie = ".((int) $searchCategoryProduct).")";
+				$searchCategoryProductSqlList[] = " EXISTS (SELECT ck.fk_product FROM " . MAIN_DB_PREFIX . "categorie_product as ck, " . MAIN_DB_PREFIX . "propaldet as pd WHERE pd.fk_propal = p.rowid AND pd.fk_product = ck.fk_product AND ck.fk_categorie = " . ((int) $searchCategoryProduct) . ")";
 			} else {
-				$listofcategoryid .= ($listofcategoryid ? ', ' : '') .((int) $searchCategoryProduct);
+				$listofcategoryid .= ($listofcategoryid ? ', ' : '') . ((int) $searchCategoryProduct);
 			}
 		}
 	}
 	if ($listofcategoryid) {
-		$searchCategoryProductSqlList[] = " EXISTS (SELECT ck.fk_product FROM ".MAIN_DB_PREFIX."categorie_product as ck, ".MAIN_DB_PREFIX."propaldet as pd WHERE pd.fk_propal = p.rowid AND pd.fk_product = ck.fk_product AND ck.fk_categorie IN (".$db->sanitize($listofcategoryid)."))";
+		$searchCategoryProductSqlList[] = " EXISTS (SELECT ck.fk_product FROM " . MAIN_DB_PREFIX . "categorie_product as ck, " . MAIN_DB_PREFIX . "propaldet as pd WHERE pd.fk_propal = p.rowid AND pd.fk_product = ck.fk_product AND ck.fk_categorie IN (" . $db->sanitize($listofcategoryid) . "))";
 	}
 	if ($searchCategoryProductOperator == 1) {
 		if (!empty($searchCategoryProductSqlList)) {
-			$sql .= " AND (".implode(' OR ', $searchCategoryProductSqlList).")";
+			$sql .= " AND (" . implode(' OR ', $searchCategoryProductSqlList) . ")";
 		}
 	} else {
 		if (!empty($searchCategoryProductSqlList)) {
-			$sql .= " AND (".implode(' AND ', $searchCategoryProductSqlList).")";
+			$sql .= " AND (" . implode(' AND ', $searchCategoryProductSqlList) . ")";
 		}
 	}
 }
 if ($search_option == 'late') {
-	$sql .= " AND p.fin_validite < '".$db->idate(dol_now() - $conf->propal->cloture->warning_delay)."'";
+	$sql .= " AND p.fin_validite < '" . $db->idate(dol_now() - $conf->propal->cloture->warning_delay) . "'";
 }
 // Add where from extra fields
-include DOL_DOCUMENT_ROOT.'/core/tpl/extrafields_list_search_sql.tpl.php';
+include DOL_DOCUMENT_ROOT . '/core/tpl/extrafields_list_search_sql.tpl.php';
 //print $sql;
 
 // Add where from hooks
@@ -855,23 +855,40 @@
 // Add HAVING from hooks
 $parameters = array();
 $reshook = $hookmanager->executeHooks('printFieldListHaving', $parameters, $object, $action); // Note that $action and $object may have been modified by hook
-$sql .= empty($hookmanager->resPrint) ? "" : " HAVING 1=1 ".$hookmanager->resPrint;
+$sql .= empty($hookmanager->resPrint) ? "" : " HAVING 1=1 " . $hookmanager->resPrint;
 
 // Count total nb of records
 $nbtotalofrecords = '';
 if (!getDolGlobalInt('MAIN_DISABLE_FULL_SCANLIST')) {
 	/* The fast and low memory method to get and count full list converts the sql into a sql count */
-	$sqlforcount = preg_replace('/^'.preg_quote($sqlfields, '/').'/', 'SELECT COUNT(*) as nbtotalofrecords', $sql);
-	$sqlforcount = preg_replace('/GROUP BY .*$/', '', $sqlforcount);
+	$parameters = array(
+		'sqlforcount' => $sql,
+		'sqlfields' => $sqlfields,
+		'context' => $parameters['context']
+	);
+
+	$reshook = $hookmanager->executeHooks('beforeCountQuery', $parameters, $object, $action);
+
+	if ($reshook > 0 && !empty($hookmanager->resPrint)) {
+		$sqlforcount = $hookmanager->resPrint;
+	} else {
+		$sqlforcount = preg_replace('/^' . preg_quote($sqlfields, '/') . '/', 'SELECT COUNT(*) as nbtotalofrecords', $sql);
+		$sqlforcount = preg_replace('/GROUP BY .*$/', '', $sqlforcount);
+	}
+
 	$resql = $db->query($sqlforcount);
 	if ($resql) {
 		$objforcount = $db->fetch_object($resql);
 		$nbtotalofrecords = $objforcount->nbtotalofrecords;
+
+		$_GET['total_ht'] = $objforcount->total_ht ?? 0;
+		$_GET['total_tva'] = $objforcount->total_tva ?? 0;
+		$_GET['total_ttc'] = $objforcount->total_ttc ?? 0;
 	} else {
 		dol_print_error($db);
 	}
 
-	if (($page * $limit) > $nbtotalofrecords) {	// if total resultset is smaller then paging size (filtering), goto and load page 0
+	if (($page * $limit) > $nbtotalofrecords) {	// if total resultset is smaller than paging size (filtering), goto and load page 0
 		$page = 0;
 		$offset = 0;
 	}
@@ -897,7 +914,7 @@
 if ($socid > 0) {
 	$soc = new Societe($db);
 	$soc->fetch($socid);
-	$title = $langs->trans('Proposals').' - '.$soc->name;
+	$title = $langs->trans('Proposals') . ' - ' . $soc->name;
 	if (empty($search_societe)) {
 		$search_societe = $soc->name;
 	}
